VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cFileDlg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
    'Copyright  2003 Chian
    'All rights reserved.
    Private Const MAX_PATH = 1024
    Private Const MAX_FILE = 512

    Public Enum SPECIAL_FOLDERS
        'Windows desktop virtual folder at root of name space
        vbCSIDL_DESKTOP = &H0&   'file system directory containing
        'user program groups, which are also file system directories
        vbCSIDL_PROGRAMS = &H2&
        'control Panel with virtual folder containing
        'icons used in control panel applications
        vbCSIDL_CONTROLS = &H3&
        'printers folder with virtual folder containing    'installed printers.
        vbCSIDL_PRINTERS = &H4&   'File system directory that serves as a
        'common repository for documents, such as My Documents folder)
        vbCSIDL_PERSONAL = &H5&
        'file system directory that contains
        'user's favourite Internet Explorer URL's
        vbCSIDL_FAVORITES = &H6&
        'file system directory corresponding to
        'user's Startup program group
        vbCSIDL_STARTUP = &H7&
        'file system directory containing user's
        'most recently used documents, such recent folder
        vbCSIDL_RECENT = &H8& 'file system directory containing
        'Send To menu items, i.e., Public Const
        vbCSIDL_SENDTO = &H9&
        'recycle bin file system directory containing file
        'objects in the user's recycle bin. The location of
        'this directory is not in the registry. it's marked
        'with hidden and system attributes to prevent user
        'moving or deleting this.
        vbCSIDL_BITBUCKET = &HA&
        'file system directory containing
        'Start menu items
        vbCSIDL_STARTMENU = &HB&
        'file system directory used to physically store
        'file objects on the desktop. not to be confused
        'with the desktop folder itself.
        vbCSIDL_DESKTOPDIRECTORY = &H10&
        'My Computer for virtual folder containing everything
        'on local computer, i.e, storage devices, printers,
        'and Control Panel. this folder may also contain
        'mapped network drives.
        vbCSIDL_DRIVES = &H11&
        'Network Neighborhood with virtual folder representing
        'top level in network hierarchy
        vbCSIDL_NETWORK = &H12&
        'file system directory containing objects
        'appearing in network neighbourhood
        vbCSIDL_NETHOOD = &H13&
        'virtual folder containing fonts
        vbCSIDL_FONTS = &H14&
        'file system directory serving as a
        'common repository for document templates    '(ShellNew folder.)
        vbCSIDL_TEMPLATES = &H15&
    End Enum
    Private Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" _
        (ByVal hWndOwner As Long, _
        ByVal nFolder As SPECIAL_FOLDERS, _
        pidl As Long) As Long 'returns NOERROR on success
    '
    'converts item identifier list to a file system path.
    Private Declare Function SHGetPathFromIDList Lib "shell32.dll" _
        Alias "SHGetPathFromIDListA" _
        (ByVal pidl As Long, _
        ByVal pszPath As String) As Long
    '
    Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal pv As Long)
    '
    Private Const NOERROR As Long = &H0
    Private Type OPENFILENAME
        lStructSize As Long          'filled with UDT size
        hWndOwner As Long            'tied to owner
        hInstance As Long            'ignored & used only by templates
        lpstrFilter As String        'tied to filter
        lpstrCustomFilter As String  'ignored [exercise for reader]
        nMaxCustFilter As Long       'ignored [exercise for reader]
        nFilterIndex As Long         'tied to filterIndex
        lpstrFile As String          'tied to file name
        nMaxFile As Long             'handled internally
        lpstrFileTitle As String     'tied to file title
        nMaxFileTitle As Long        'handled internally
        lpstrInitialDir As String    'tied to initial directory
        lpstrTitle As String         'tied to dialogue title
        Flags As Long                'tied to flags
        nFileOffset As Integer       'ignored [exercise for reader]
        nFileExtension As Integer    'ignored [exercise for reader]
        lpstrDefExt As String        'tied to default file name extension
        lCustData As Long            'ignored [required for hooks]
        lpfnHook As Long             'ignored [used with hooks]
        lpTemplateName As Long       'ignored [used with templates]
    End Type
    '
    Private Declare Function GetOpenFileName Lib "COMDLG32" _
        Alias "GetOpenFileNameA" (filestruct As OPENFILENAME) As Long
    Private Declare Function GetSaveFileName Lib "COMDLG32" _
        Alias "GetSaveFileNameA" (filestruct As OPENFILENAME) As Long
    Private Declare Function GetFileTitle Lib "COMDLG32" _
        Alias "GetFileTitleA" (ByVal szFile As String, _
        ByVal szTitle As String, ByVal cbBuf As Integer) As Integer
    'VFW "customized" File Dialogs
    Private Declare Function GetOpenFileNamePreview Lib "MSVFW32" _
        Alias "GetOpenFileNamePreviewA" (filestruct As OPENFILENAME) As Long
    Private Declare Function GetSaveFileNamePreview Lib "MSVFW32" _
        Alias "GetSaveFileNamePreviewA" (filestruct As OPENFILENAME) As Long
    '
    Public Enum EOpenFile
        OFN_READONLY = &H1&
        OFN_OVERWRITEPROMPT = &H2&
        OFN_HIDEREADONLY = &H4&
        OFN_NOCHANGEDIR = &H8&
        OFN_SHOWHELP = &H10&
        OFN_ENABLEHOOK = &H20&
        OFN_ENABLETEMPLATE = &H40&
        OFN_ENABLETEMPLATEHANDLE = &H80&
        OFN_NOVALIDATE = &H100&
        OFN_ALLOWMULTISELECT = &H200&
        OFN_EXTENSIONDIFFERENT = &H400&
        OFN_PATHMUSTEXIST = &H800&
        OFN_FILEMUSTEXIST = &H1000&
        OFN_CREATEPROMPT = &H2000&
        OFN_SHAREAWARE = &H4000&
        OFN_NOREADONLYRETURN = &H8000&
        OFN_NOTESTFILECREATE = &H10000
        OFN_NONETWORKBUTTON = &H20000
        OFN_NOLONGNAMES = &H40000
        OFN_EXPLORER = &H80000
        OFN_NODEREFERENCELINKS = &H100000
        OFN_LONGNAMES = &H200000
    End Enum
    '
    Private Declare Function CommDlgExtendedError Lib "COMDLG32" () As Long
    '
    Public Enum EDialogError
        CDERR_DIALOGFAILURE = &HFFFF&
        CDERR_GENERALCODES = &H0&
        CDERR_STRUCTSIZE = &H1&
        CDERR_INITIALIZATION = &H2&
        CDERR_NOTEMPLATE = &H3&
        CDERR_NOHINSTANCE = &H4&
        CDERR_LOADSTRFAILURE = &H5&
        CDERR_FINDRESFAILURE = &H6&
        CDERR_LOADRESFAILURE = &H7&
        CDERR_LOCKRESFAILURE = &H8&
        CDERR_MEMALLOCFAILURE = &H9&
        CDERR_MEMLOCKFAILURE = &HA&
        CDERR_NOHOOK = &HB&
        CDERR_REGISTERMSGFAIL = &HC&
        PDERR_PRINTERCODES = &H1000&
        PDERR_SETUPFAILURE = &H1001&
        PDERR_PARSEFAILURE = &H1002&
        PDERR_RETDEFFAILURE = &H1003&
        PDERR_LOADDRVFAILURE = &H1004&
        PDERR_GETDEVMODEFAIL = &H1005&
        PDERR_INITFAILURE = &H1006&
        PDERR_NODEVICES = &H1007&
        PDERR_NODEFAULTPRN = &H1008&
        PDERR_DNDMMISMATCH = &H1009&
        PDERR_CREATEICFAILURE = &H100A&
        PDERR_PRINTERNOTFOUND = &H100B&
        PDERR_DEFAULTDIFFERENT = &H100C&
        CFERR_CHOOSEFONTCODES = &H2000&
        CFERR_NOFONTS = &H2001&
        CFERR_MAXLESSTHANMIN = &H2002&
        FNERR_FILENAMECODES = &H3000&
        FNERR_SUBCLASSFAILURE = &H3001&
        FNERR_INVALIDFILENAME = &H3002&
        FNERR_BUFFERTOOSMALL = &H3003&
        CCERR_CHOOSECOLORCODES = &H5000&
    End Enum
    '
    Private Const sEmpty As String = ""
    '
    'class member variables
    Private mb_multiselect As Boolean
    Private mb_readonly As Boolean
    Private mb_filemustexist As Boolean
    Private m_filter$
    Private mb_hidereadonly As Boolean
    Private m_filterindex&
    Private m_initdir$
    Private m_dlgtitle$
    Private m_defaultext$
    Private m_hwnd&
    Private mb_overwriteprompt As Boolean
    Private m_flags&

Private Sub Class_Initialize()
    'initialise default values
    On Error GoTo localErr
    m_hwnd& = -1&
    mb_filemustexist = True
    mb_multiselect = False
    mb_hidereadonly = True
    m_dlgtitle$ = App.title
    mb_overwriteprompt = True
    m_initdir$ = GetSpecialFolderLocation(vbCSIDL_PERSONAL) 'default to My Documents folder
    Exit Sub

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Sub

Property Get OwnerHwnd() As Long
    On Error GoTo localErr
    OwnerHwnd = m_hwnd&
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Let OwnerHwnd(ByVal vHwnd As Long)
    On Error GoTo localErr
    m_hwnd& = vHwnd
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Get FileMustExist() As Boolean
    On Error GoTo localErr
    FileMustExist = mb_filemustexist
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Let FileMustExist(ByVal vNewValue As Boolean)
    On Error GoTo localErr
    mb_filemustexist = vNewValue
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Get MultiSelect() As Boolean
    On Error GoTo localErr
    MultiSelect = mb_multiselect
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Let MultiSelect(ByVal vNewValue As Boolean)
    On Error GoTo localErr
    mb_multiselect = vNewValue
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Get ReadOnly() As Boolean
    On Error GoTo localErr
    ReadOnly = mb_readonly
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Get HideReadOnly() As Boolean
    On Error GoTo localErr
    HideReadOnly = mb_hidereadonly
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Let HideReadOnly(ByVal vNewValue As Boolean)
    On Error GoTo localErr
    mb_hidereadonly = vNewValue
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Get Filter() As String
    On Error GoTo localErr
    Filter = m_filter$
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Let Filter(ByVal vFilterString As String)
    On Error GoTo localErr
    m_filter$ = vFilterString
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Get FilterIndex() As Long
    On Error GoTo localErr
    FilterIndex = m_filterindex&
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Let FilterIndex(ByVal vIndex As Long)
    On Error GoTo localErr
    m_filterindex& = vIndex
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Get InitDirectory() As String
    On Error GoTo localErr
    InitDirectory = m_initdir$
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Let InitDirectory(ByVal DirPath As String)
    On Error GoTo localErr
    m_initdir$ = DirPath
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Let InitDirectorySpecial(ByVal SpecialDirectory As SPECIAL_FOLDERS)
    On Error GoTo localErr
    m_initdir$ = GetSpecialFolderLocation(SpecialDirectory)
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Get DlgTitle() As String
    On Error GoTo localErr
    DlgTitle = m_dlgtitle$
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property
Property Let DlgTitle(ByVal title As String)
    On Error GoTo localErr
    m_dlgtitle$ = title
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Get DefaultExt() As String
    On Error GoTo localErr
    DefaultExt = m_defaultext$
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Let DefaultExt(ByVal fileExt As String)
    On Error GoTo localErr
    m_defaultext$ = fileExt
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Get Flags() As EOpenFile
    On Error GoTo localErr
    Flags = m_flags&
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Let Flags(ByVal vFlags As EOpenFile)
    On Error GoTo localErr
    m_flags& = vFlags
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Get OverwritePrompt() As Boolean
    On Error GoTo localErr
    OverwritePrompt = mb_overwriteprompt
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Property Let OverwritePrompt(ByVal vShowPrompt As Boolean)
    On Error GoTo localErr
    mb_overwriteprompt = vShowPrompt
    Exit Property

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Property

Public Function VBGetOpenFileName(filename As String, _
    Optional filetitle As String) As Boolean
    On Error GoTo localErr
    Dim OFNAME As OPENFILENAME
    Dim buffer$
    Dim chunk$
    Dim i%
    
    With OFNAME
        .lStructSize = Len(OFNAME)
        'add specific flags and strip non-VB flags
        .Flags = (-mb_filemustexist * OFN_FILEMUSTEXIST) Or _
             (-mb_multiselect * OFN_ALLOWMULTISELECT) Or _
             (-mb_readonly * OFN_READONLY) Or _
             (-mb_hidereadonly * OFN_HIDEREADONLY) Or _
             (m_flags& And CLng(Not (OFN_ENABLEHOOK Or _
                                  OFN_ENABLETEMPLATE)))
        If m_hwnd& <> -1 Then .hWndOwner = m_hwnd&
        .lpstrInitialDir = m_initdir$
        .lpstrDefExt = m_defaultext$
        .lpstrTitle = m_dlgtitle$
        'make windows style filter, replace | and : with nulls
        For i% = 1 To Len(Filter)
            chunk$ = Mid$(Filter, i%, 1)
            If chunk$ = "|" Or chunk$ = ":" Then
                buffer$ = buffer$ & vbNullChar
            Else
                buffer$ = buffer$ & chunk$
            End If
        Next
        'appends pair of nulls
        buffer$ = buffer$ & vbNullChar & vbNullChar
        .lpstrFilter = buffer$
        .nFilterIndex = m_filterindex&
        'pad file & file title buffers for maximum path
        buffer$ = filename & String$(MAX_PATH - Len(filename), 0)
        .lpstrFile = buffer$
        .nMaxFile = MAX_PATH
        buffer$ = filetitle & String$(MAX_FILE - Len(filetitle), 0)
        .lpstrFileTitle = buffer$
        .nMaxFileTitle = MAX_FILE
        'other fields set to zero
        If GetOpenFileName(OFNAME) Then
            VBGetOpenFileName = True
            filename = Left$(.lpstrFile, InStr(.lpstrFile, vbNullChar) - 1)
            filetitle = Left$(.lpstrFileTitle, InStr(.lpstrFileTitle, vbNullChar) - 1)
            m_flags& = .Flags
            m_filterindex& = .nFilterIndex
            m_filter$ = FilterLookup(.lpstrFilter, m_filterindex&)
            If (.Flags And OFN_READONLY) Then mb_readonly = True
            m_initdir$ = .lpstrFile
        Else
            VBGetOpenFileName = False
            filename = vbNullChar
            filetitle = vbNullChar
            Flags = 0
            FilterIndex = -1
            Filter = vbNullChar
        End If
    End With
    Exit Function

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Function

Public Function VBGetOpenFileNamePreview(filename As String, _
    Optional filetitle As String) As Boolean
    On Error GoTo localErr
    Dim OFNAME As OPENFILENAME
    Dim buffer$
    Dim chunk$
    Dim i%
    
    With OFNAME
        .lStructSize = Len(OFNAME)
        'add specific flags and strip out non-VB flags
        .Flags = (-mb_filemustexist * OFN_FILEMUSTEXIST) Or _
            (-mb_multiselect * OFN_ALLOWMULTISELECT) Or _
            (-mb_readonly * OFN_READONLY) Or _
            (-mb_hidereadonly * OFN_HIDEREADONLY) Or _
            (m_flags& And CLng(Not (OFN_ENABLEHOOK Or _
                OFN_ENABLETEMPLATE)))
        If m_hwnd& <> -1 Then .hWndOwner = m_hwnd&
        .lpstrInitialDir = m_initdir$
        .lpstrDefExt = m_defaultext$
        .lpstrTitle = m_dlgtitle$
        'make Windows-style filter, replace | and : with nulls
        For i% = 1 To Len(Filter)
            chunk$ = Mid$(Filter, i%, 1)
            If chunk$ = "|" Or chunk$ = ":" Then
                buffer$ = buffer$ & vbNullChar
            Else
                buffer$ = buffer$ & chunk$
            End If
        Next
        'appends pair of nulls
        buffer$ = buffer$ & vbNullChar & vbNullChar
        .lpstrFilter = buffer$
        .nFilterIndex = m_filterindex&
        'pad file and file title buffers for maximum path
        buffer$ = filename & String$(MAX_PATH - Len(filename), 0)
        .lpstrFile = buffer$
        .nMaxFile = MAX_PATH
        buffer$ = filetitle & String$(MAX_FILE - Len(filetitle), 0)
        .lpstrFileTitle = buffer$
        .nMaxFileTitle = MAX_FILE
        'set other fields to zero
        If GetOpenFileNamePreview(OFNAME) Then
            VBGetOpenFileNamePreview = True
            filename = Left$(.lpstrFile, InStr(.lpstrFile, vbNullChar) - 1)
            filetitle = Left$(.lpstrFileTitle, InStr(.lpstrFileTitle, vbNullChar) - 1)
            m_flags& = .Flags
            m_filterindex& = .nFilterIndex
            m_filter$ = FilterLookup(.lpstrFilter, m_filterindex&)
            If (.Flags And OFN_READONLY) Then mb_readonly = True
            m_initdir$ = .lpstrFile
        Else
            VBGetOpenFileNamePreview = False
            filename = vbNullChar
            filetitle = vbNullChar
            Flags = 0
            FilterIndex = -1
            Filter = vbNullChar
        End If
    End With
    Exit Function

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Function

Public Function VBGetSaveFileName(filename As String, _
    Optional filetitle As String) As Boolean
    On Error GoTo localErr
    Dim OFNAME As OPENFILENAME
    Dim buffer$
    Dim chunk$
    Dim i%

    With OFNAME
        .lStructSize = Len(OFNAME)
        'add specific flags and strip out non-VB flags
        .Flags = (-mb_overwriteprompt * OFN_OVERWRITEPROMPT) Or _
            OFN_HIDEREADONLY Or _
            (m_flags& And CLng(Not (OFN_ENABLEHOOK Or _
            OFN_ENABLETEMPLATE)))
        If m_hwnd& <> -1 Then .hWndOwner = m_hwnd&
        .lpstrInitialDir = m_initdir$
        .lpstrDefExt = m_defaultext$
        .lpstrTitle = m_dlgtitle$
        'make new filter with bars (|) replace nulls and double nulls at end
        For i% = 1 To Len(Filter)
            chunk$ = Mid$(Filter, i%, 1)
            If chunk$ = "|" Or chunk$ = ":" Then
                buffer$ = buffer$ & vbNullChar
            Else
                buffer$ = buffer$ & chunk$
            End If
        Next
        'appends pair of nulls
        buffer$ = buffer$ & vbNullChar & vbNullChar
        .lpstrFilter = buffer$
        .nFilterIndex = m_filterindex&
        'pad file and file title buffers for maximum path
        buffer$ = filename & String$(MAX_PATH - Len(filename), 0)
        .lpstrFile = buffer$
        .nMaxFile = MAX_PATH
        buffer$ = filetitle & String$(MAX_FILE - Len(filetitle), 0)
        .lpstrFileTitle = buffer$
        .nMaxFileTitle = MAX_FILE
        'set other fields to zero
        If GetSaveFileName(OFNAME) Then
            VBGetSaveFileName = True
            filename = Left$(.lpstrFile, InStr(.lpstrFile, vbNullChar) - 1)
            filetitle = Left$(.lpstrFileTitle, InStr(.lpstrFileTitle, vbNullChar) - 1)
            m_flags& = .Flags
            m_filterindex& = .nFilterIndex
            m_filter$ = FilterLookup(.lpstrFilter, FilterIndex)
            m_initdir$ = .lpstrFile
        Else
            VBGetSaveFileName = False
            filename = vbNullChar
            filetitle = vbNullChar
            m_flags& = 0
            m_filterindex& = 0
            m_filter$ = vbNullChar
        End If
    End With
    Exit Function

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Function

Private Function FilterLookup(ByVal sFilters As String, ByVal iCur As Long) As String
    On Error GoTo localErr
    Dim spos&
    Dim epos&
    Dim buffer$
    
    spos& = 1
    If sFilters = vbNullChar Then Exit Function
    Do
        'removes both parts marked by null character
        epos& = InStr(spos&, sFilters, vbNullChar)
        If epos& = 0 Then Exit Function
        epos& = InStr(epos& + 1, sFilters, vbNullChar)
        If epos& Then
            buffer$ = Mid$(sFilters, spos&, epos& - spos&)
        Else
            buffer$ = Mid$(sFilters, spos&)
        End If
        spos& = epos& + 1
        If iCur = 1 Then
            FilterLookup = buffer$
            Exit Function
        End If
        iCur = iCur - 1
    Loop While iCur
    Exit Function

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Function

Private Function StrZToStr(s As String) As String
    On Error GoTo localErr
    Dim temp$
    
    temp$ = Left$(s, InStr(s, vbNullChar) - 1)
    If temp$ = "" Then
        'if VB string accidently passed their can't be NULL
        'so returne original string
        StrZToStr = s
    Else
        StrZToStr = temp$
    End If
    Exit Function

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Function

Private Function GetSpecialFolderLocation(CSIDL As SPECIAL_FOLDERS) As String
    On Error GoTo localErr
    Dim dpath$
    Dim pidl As Long
   
    'fill idl structure with
    'specified folder item
   If SHGetSpecialFolderLocation(m_hwnd&, CSIDL, pidl) = NOERROR Then
        'if pidl is returned, initialise
        'and get path from id list
        dpath$ = Space$(MAX_PATH)
        If SHGetPathFromIDList(ByVal pidl, ByVal dpath$) Then
            'free pidl and return path
            Call CoTaskMemFree(ByVal VarPtr(pidl))
            GetSpecialFolderLocation = Left(dpath$, InStr(dpath$, Chr$(0)) - 1)
        End If
    End If
    Exit Function

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Function

Public Function ExistFile(ByVal sSpec As String) As Boolean
    On Error GoTo localErr
    'check file existence
    On Error Resume Next
    Call FileLen(sSpec)
    ExistFile = (Err = 0)
    Exit Function

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Function

Public Function VBGetFileTitle(sFile As String) As String
    'gets file title [file name without path]
    'from any full path
    On Error GoTo localErr
    Dim filetitle$
    Dim isfiletitle%

    isfiletitle% = MAX_PATH
    filetitle$ = String$(MAX_PATH, 0)
    isfiletitle% = GetFileTitle(sFile, filetitle$, MAX_PATH)
    If isfiletitle% Then
        VBGetFileTitle = ""
    Else
        VBGetFileTitle = Left$(filetitle$, InStr(filetitle$, vbNullChar) - 1)
    End If
    Exit Function

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Function


